/* A node is a set of three doubles i.e 3d vector */

public class Node
{


  public double x;
  public double y;
  public double z;
  public String name;


  public Node(double inx, double iny, double inz, String inName)
  {
    x = inx;
    y = iny;
    z = inz;
    name = inName;
  }

  public String toString()
  {
    return "[" + x + "," + y + "," + z + "," + name + "]";
  }

  public boolean isOrigin()
  {
    if (x==0 && y==0 && z==0)
      return true;

    return false;
  }


  // returns a node which is the result of subtracting node 'a' from this
  public Node subtractNode(Node a)
  {
    Node result = new Node(x-a.x, y-a.y, z-a.z, name + "-" + a.name);
    return result;
  }

  // returns a node which is the result of adding node 'a' from this
  public Node addNode(Node a)
  {
    Node result = new Node(x+a.x, y+a.y, z+a.z, name + "+" + a.name);
    return result;
  }

  public Node scaleNode(double factor)
  {
    Node result = new Node(x*factor,y*factor,z*factor,name+"*"+factor);
    return result;
  }


  // returns the vector which is the cross product of 2 vectors this and b
  public Node crossProduct(Node b)
  {
    double i,j,k;

    i = y*b.z - z*b.y;
    j = z*b.x - x*b.z;
    k = x*b.y - b.x*y;
    
    return new Node(i,j,k, name + "X" + b.name);
  }

  
  public double dotProduct(Node b)
  {
    double dp = x*b.x + y*b.y + z*b.z;
    return dp;
  }

  public boolean equals(Node a)
  {
    if (x==a.x && y==a.y && z==a.z)
      return true;
    return false;
  }


  public Node normalise()
  {
    double sum = Math.sqrt(x*x + y*y + z*z);
    
    if (sum == 0)
      {
	System.err.println("Division by 0 in node.normalise");
	return null;
      }

    Node result = new Node(x/sum, y/sum, z/sum, name);
    return result;
  }

  public double norm()
  {
    double sum = Math.sqrt(x*x + y*y + z*z);
    return sum;
  }
  
}

